<?php
namespace SBublies\Gridtocontainer\Command;

/***
 *
 * This file is part of the "Gridtocontainer" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2022 by Stefan Bublies <project@sbublies.de>
 *
 ***/

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Style\SymfonyStyle;

class MigrateAllCommand extends Command
{
	/**
	 * Configure the command by defining the name, options and arguments
	 */
	protected function configure(): void
	{

		$this->addArgument('grididentifier',InputArgument::REQUIRED,'Gridelements identifier to migrate all the elements from this type')
			->addArgument('containeridentifier', InputArgument::REQUIRED, 'The new EXT:container element-identifier e.g. ce_columns2')
			->addArgument('flexformidentifier', InputArgument::REQUIRED, 'If you want a clean flexform field, write "clean". If you want a flexform from the TCA write the identifier')
			->addArgument('columnids',InputArgument::IS_ARRAY | InputArgument::REQUIRED, 'Column-ID/s, separated with a space. It must be used at the end of the argument list')
			->setHelp('Migrate gridelements to container.' . LF . 'You must have registered the EXT:container elements before! And please make a backup from your database before start the migration'.LF.'This function migrates all gridelements and content elements with the selected gridelements-layout keys. Not tested is a migration of nested grid elements');

	}

	/**
	 * Executes the command to migrate the elements
	 *
	 * @param InputInterface $input
	 * @param OutputInterface $output
	 * @return int error code
	 */
	protected function execute(InputInterface $input, OutputInterface $output)
	{
		$io = new SymfonyStyle($input, $output);
		$io->title($this->getDescription());

		// ...
		$io->writeln('Write something');
		return Command::SUCCESS;
	}
}
